"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var contracts_test_utils_1 = require("@0x/contracts-test-utils");
var dev_utils_1 = require("@0x/dev-utils");
var utils_1 = require("@0x/utils");
var chai = require("chai");
var src_1 = require("../src");
contracts_test_utils_1.chaiSetup.configure();
var expect = chai.expect;
var blockchainLifecycle = new dev_utils_1.BlockchainLifecycle(contracts_test_utils_1.web3Wrapper);
describe('Libs tests', function () {
    var testLibs;
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, src_1.TestLibsContract.deployFrom0xArtifactAsync(src_1.artifacts.TestLibs, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults)];
                case 1:
                    testLibs = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    describe('getTransactionHash', function () {
        it('should return the correct transaction hash', function () { return __awaiter(_this, void 0, void 0, function () {
            var tx, expectedTxHash, txHash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        tx = {
                            verifyingContractAddress: testLibs.address,
                            salt: new utils_1.BigNumber(0),
                            signerAddress: contracts_test_utils_1.constants.NULL_ADDRESS,
                            data: '0x1234',
                        };
                        expectedTxHash = src_1.hashUtils.getTransactionHashHex(tx);
                        return [4 /*yield*/, testLibs.publicGetTransactionHash.callAsync(tx)];
                    case 1:
                        txHash = _a.sent();
                        expect(expectedTxHash).to.eq(txHash);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getApprovalHash', function () {
        it('should return the correct approval hash', function () { return __awaiter(_this, void 0, void 0, function () {
            var signedTx, approvalExpirationTimeSeconds, approval, expectedApprovalHash, approvalHash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        signedTx = {
                            verifyingContractAddress: testLibs.address,
                            salt: new utils_1.BigNumber(0),
                            signerAddress: contracts_test_utils_1.constants.NULL_ADDRESS,
                            data: '0x1234',
                            signature: '0x5678',
                        };
                        approvalExpirationTimeSeconds = new utils_1.BigNumber(0);
                        approval = {
                            transactionHash: src_1.hashUtils.getTransactionHashHex(signedTx),
                            transactionSignature: signedTx.signature,
                            approvalExpirationTimeSeconds: approvalExpirationTimeSeconds,
                        };
                        expectedApprovalHash = src_1.hashUtils.getApprovalHashHex(signedTx, approvalExpirationTimeSeconds);
                        return [4 /*yield*/, testLibs.publicGetTECApprovalHash.callAsync(approval)];
                    case 1:
                        approvalHash = _a.sent();
                        expect(expectedApprovalHash).to.eq(approvalHash);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=libs.js.map