"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var contracts_test_utils_1 = require("@0x/contracts-test-utils");
var dev_utils_1 = require("@0x/dev-utils");
var types_1 = require("@0x/types");
var utils_1 = require("@0x/utils");
var chai = require("chai");
var ethUtil = require("ethereumjs-util");
var src_1 = require("../src");
contracts_test_utils_1.chaiSetup.configure();
var expect = chai.expect;
var blockchainLifecycle = new dev_utils_1.BlockchainLifecycle(contracts_test_utils_1.web3Wrapper);
describe('Mixins tests', function () {
    var transactionSignerAddress;
    var approvalSignerAddress1;
    var approvalSignerAddress2;
    var mixins;
    var transactionFactory;
    var approvalFactory1;
    var approvalFactory2;
    var defaultOrder;
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, accounts, transactionSignerPrivateKey, approvalSignerPrivateKey1, approvalSignerPrivateKey2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, src_1.TestMixinsContract.deployFrom0xArtifactAsync(src_1.artifacts.TestMixins, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults)];
                case 1:
                    mixins = _b.sent();
                    return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.getAvailableAddressesAsync()];
                case 2:
                    accounts = _b.sent();
                    _a = __read(accounts.slice(0, 3), 3), transactionSignerAddress = _a[0], approvalSignerAddress1 = _a[1], approvalSignerAddress2 = _a[2];
                    defaultOrder = {
                        exchangeAddress: contracts_test_utils_1.constants.NULL_ADDRESS,
                        makerAddress: contracts_test_utils_1.constants.NULL_ADDRESS,
                        takerAddress: contracts_test_utils_1.constants.NULL_ADDRESS,
                        senderAddress: mixins.address,
                        feeRecipientAddress: approvalSignerAddress1,
                        makerAssetData: contracts_test_utils_1.constants.NULL_BYTES,
                        takerAssetData: contracts_test_utils_1.constants.NULL_BYTES,
                        makerAssetAmount: contracts_test_utils_1.constants.ZERO_AMOUNT,
                        takerAssetAmount: contracts_test_utils_1.constants.ZERO_AMOUNT,
                        makerFee: contracts_test_utils_1.constants.ZERO_AMOUNT,
                        takerFee: contracts_test_utils_1.constants.ZERO_AMOUNT,
                        expirationTimeSeconds: contracts_test_utils_1.constants.ZERO_AMOUNT,
                        salt: contracts_test_utils_1.constants.ZERO_AMOUNT,
                        signature: contracts_test_utils_1.constants.NULL_BYTES,
                    };
                    transactionSignerPrivateKey = contracts_test_utils_1.constants.TESTRPC_PRIVATE_KEYS[accounts.indexOf(transactionSignerAddress)];
                    approvalSignerPrivateKey1 = contracts_test_utils_1.constants.TESTRPC_PRIVATE_KEYS[accounts.indexOf(approvalSignerAddress1)];
                    approvalSignerPrivateKey2 = contracts_test_utils_1.constants.TESTRPC_PRIVATE_KEYS[accounts.indexOf(approvalSignerAddress2)];
                    transactionFactory = new src_1.TECTransactionFactory(transactionSignerPrivateKey, mixins.address);
                    approvalFactory1 = new src_1.ApprovalFactory(approvalSignerPrivateKey1, mixins.address);
                    approvalFactory2 = new src_1.ApprovalFactory(approvalSignerPrivateKey2, mixins.address);
                    return [2 /*return*/];
            }
        });
    }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    describe('getSignerAddress', function () {
        it('should return the correct address using the EthSign signature type', function () { return __awaiter(_this, void 0, void 0, function () {
            var data, transaction, transactionHash, signerAddress;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = contracts_test_utils_1.constants.NULL_BYTES;
                        transaction = transactionFactory.newSignedTECTransaction(data, src_1.TECSignatureType.EthSign);
                        transactionHash = src_1.hashUtils.getTransactionHashHex(transaction);
                        return [4 /*yield*/, mixins.getSignerAddress.callAsync(transactionHash, transaction.signature)];
                    case 1:
                        signerAddress = _a.sent();
                        expect(transaction.signerAddress).to.eq(signerAddress);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return the correct address using the EIP712 signature type', function () { return __awaiter(_this, void 0, void 0, function () {
            var data, transaction, transactionHash, signerAddress;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = contracts_test_utils_1.constants.NULL_BYTES;
                        transaction = transactionFactory.newSignedTECTransaction(data, src_1.TECSignatureType.EIP712);
                        transactionHash = src_1.hashUtils.getTransactionHashHex(transaction);
                        return [4 /*yield*/, mixins.getSignerAddress.callAsync(transactionHash, transaction.signature)];
                    case 1:
                        signerAddress = _a.sent();
                        expect(transaction.signerAddress).to.eq(signerAddress);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should revert with with the Illegal signature type', function () { return __awaiter(_this, void 0, void 0, function () {
            var data, transaction, illegalSignatureByte, transactionHash;
            return __generator(this, function (_a) {
                data = contracts_test_utils_1.constants.NULL_BYTES;
                transaction = transactionFactory.newSignedTECTransaction(data);
                illegalSignatureByte = ethUtil.toBuffer(src_1.TECSignatureType.Illegal).toString('hex');
                transaction.signature = "" + transaction.signature.slice(0, transaction.signature.length - 2) + illegalSignatureByte;
                transactionHash = src_1.hashUtils.getTransactionHashHex(transaction);
                contracts_test_utils_1.expectContractCallFailedAsync(mixins.getSignerAddress.callAsync(transactionHash, transaction.signature), types_1.RevertReason.SignatureIllegal);
                return [2 /*return*/];
            });
        }); });
        it("should revert with with a signature type that doesn't exist", function () { return __awaiter(_this, void 0, void 0, function () {
            var data, transaction, invalidSignatureByte, transactionHash;
            return __generator(this, function (_a) {
                data = contracts_test_utils_1.constants.NULL_BYTES;
                transaction = transactionFactory.newSignedTECTransaction(data);
                invalidSignatureByte = '03';
                transaction.signature = "" + transaction.signature.slice(0, transaction.signature.length - 2) + invalidSignatureByte;
                transactionHash = src_1.hashUtils.getTransactionHashHex(transaction);
                contracts_test_utils_1.expectContractCallFailedAsync(mixins.getSignerAddress.callAsync(transactionHash, transaction.signature), types_1.RevertReason.SignatureUnsupported);
                return [2 /*return*/];
            });
        }); });
    });
    describe('Single order approvals', function () {
        var e_1, _a;
        var _loop_1 = function (fnName) {
            it("Should be successful: function=" + fnName + ", caller=tx_signer, senderAddress=[verifier], approval_sig=[approver1], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + ", caller=tx_signer, senderAddress=[null], approval_sig=[approver1], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var order, orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            order = __assign({}, defaultOrder, { senderAddress: contracts_test_utils_1.constants.NULL_ADDRESS });
                            orders = [order];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + ", caller=approver1, senderAddress=[verifier], approval_sig=[], expiration=[]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [], [], { from: approvalSignerAddress1 })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [], [], {
                                    from: approvalSignerAddress1,
                                })];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + ", caller=approver1, senderAddress=[verifier], approval_sig=[approver1], expiration=[invalid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: approvalSignerAddress1 })];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: approvalSignerAddress1 })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + ", caller=approver1, senderAddress=[verifier], approval_sig=[], expiration=[]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [], [], { from: approvalSignerAddress1 })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [], [], {
                                    from: approvalSignerAddress1,
                                })];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should revert: function=" + fnName + ", caller=tx_signer, senderAddress=[verifier], approval_sig=[invalid], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval, signature;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            signature = approval.signature.slice(0, 4) + "FFFFFFFF" + approval.signature.slice(12);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [signature], { from: transactionSignerAddress }), types_1.RevertReason.InvalidApprovalSignature);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [signature], { from: transactionSignerAddress }), types_1.RevertReason.InvalidApprovalSignature);
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should revert: function=" + fnName + ", caller=tx_signer, senderAddress=[verifier], approval_sig=[approver1], expiration=[invalid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).minus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress }), types_1.RevertReason.ApprovalExpired);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress }), types_1.RevertReason.ApprovalExpired);
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should revert: function=" + fnName + ", caller=approver2, senderAddress=[verifier], approval_sig=[approver1], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: approvalSignerAddress2 }), types_1.RevertReason.InvalidSender);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: approvalSignerAddress2 }), types_1.RevertReason.InvalidSender);
                            return [2 /*return*/];
                    }
                });
            }); });
        };
        try {
            for (var _b = __values(src_1.constants.SINGLE_FILL_FN_NAMES), _c = _b.next(); !_c.done; _c = _b.next()) {
                var fnName = _c.value;
                _loop_1(fnName);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
    describe('Batch order approvals', function () {
        var e_2, _a;
        var _loop_2 = function (fnName) {
            it("Should be successful: function=" + fnName + " caller=tx_signer, senderAddress=[verifier,verifier], feeRecipient=[approver1,approver1], approval_sig=[approver1], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + " caller=tx_signer, senderAddress=[null,null], feeRecipient=[approver1,approver1], approval_sig=[approver1], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, defaultOrder].map(function (order) { return (__assign({}, order, { senderAddress: contracts_test_utils_1.constants.NULL_ADDRESS })); });
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + " caller=tx_signer, senderAddress=[null,null], feeRecipient=[approver1,approver1], approval_sig=[], expiration=[]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, defaultOrder].map(function (order) { return (__assign({}, order, { senderAddress: contracts_test_utils_1.constants.NULL_ADDRESS })); });
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [], [], { from: transactionSignerAddress })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [], [], {
                                    from: transactionSignerAddress,
                                })];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + " caller=tx_signer, senderAddress=[verifier,null], feeRecipient=[approver1,approver1], approval_sig=[approver1], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, __assign({}, defaultOrder, { senderAddress: contracts_test_utils_1.constants.NULL_ADDRESS })];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: transactionSignerAddress })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + " caller=tx_signer, senderAddress=[verifier,verifier], feeRecipient=[approver1,approver2], approval_sig=[approver1,approver2], expiration=[valid,valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval1, approval2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, __assign({}, defaultOrder, { feeRecipientAddress: approvalSignerAddress2 })];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval1 = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            approval2 = approvalFactory2.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds, approvalExpirationTimeSeconds], [approval1.signature, approval2.signature], { from: transactionSignerAddress })];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds, approvalExpirationTimeSeconds], [approval1.signature, approval2.signature], { from: transactionSignerAddress })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + " caller=approver1, senderAddress=[verifier,verifier], feeRecipient=[approver1,approver1], approval_sig=[], expiration=[]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [], [], { from: approvalSignerAddress1 })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [], [], {
                                    from: approvalSignerAddress1,
                                })];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should be successful: function=" + fnName + " caller=approver1, senderAddress=[verifier,verifier], feeRecipient=[approver1,approver2], approval_sig=[approver2], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, __assign({}, defaultOrder, { feeRecipientAddress: approvalSignerAddress2 })];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval2 = approvalFactory2.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval2.signature], { from: approvalSignerAddress1 })];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval2.signature], { from: approvalSignerAddress1 })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should revert: function=" + fnName + " caller=tx_signer, senderAddress=[verifier,verifier], feeRecipient=[approver1, approver1], approval_sig=[], expiration=[]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction;
                return __generator(this, function (_a) {
                    orders = [defaultOrder, defaultOrder];
                    data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                    transaction = transactionFactory.newSignedTECTransaction(data);
                    contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [], [], { from: transactionSignerAddress }), types_1.RevertReason.InvalidApprovalSignature);
                    contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [], [], {
                        from: transactionSignerAddress,
                    }), types_1.RevertReason.InvalidApprovalSignature);
                    return [2 /*return*/];
                });
            }); });
            it("Should revert: function=" + fnName + " caller=tx_signer, senderAddress=[verifier,verifier], feeRecipient=[approver1, approver1], approval_sig=[invalid], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval, signature;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            signature = approval.signature.slice(0, 4) + "FFFFFFFF" + approval.signature.slice(12);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [signature], { from: transactionSignerAddress }), types_1.RevertReason.InvalidApprovalSignature);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [signature], { from: transactionSignerAddress }), types_1.RevertReason.InvalidApprovalSignature);
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should revert: function=" + fnName + " caller=tx_signer, senderAddress=[verifier,verifier], feeRecipient=[approver1, approver2], approval_sig=[valid,invalid], expiration=[valid,valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval1, approval2, approvalSignature2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, __assign({}, defaultOrder, { feeRecipientAddress: approvalSignerAddress2 })];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval1 = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            approval2 = approvalFactory2.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            approvalSignature2 = approval2.signature.slice(0, 4) + "FFFFFFFF" + approval2.signature.slice(12);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds, approvalExpirationTimeSeconds], [approval1.signature, approvalSignature2], { from: transactionSignerAddress }), types_1.RevertReason.InvalidApprovalSignature);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds, approvalExpirationTimeSeconds], [approval1.signature, approvalSignature2], { from: transactionSignerAddress }), types_1.RevertReason.InvalidApprovalSignature);
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should revert: function=" + fnName + " caller=approver1, senderAddress=[verifier,verifier], feeRecipient=[approver1, approver2], approval_sig=[invalid], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval2, approvalSignature2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, __assign({}, defaultOrder, { feeRecipientAddress: approvalSignerAddress2 })];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval2 = approvalFactory2.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            approvalSignature2 = approval2.signature.slice(0, 4) + "FFFFFFFF" + approval2.signature.slice(12);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approvalSignature2], { from: approvalSignerAddress1 }), types_1.RevertReason.InvalidApprovalSignature);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approvalSignature2], { from: approvalSignerAddress1 }), types_1.RevertReason.InvalidApprovalSignature);
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should revert: function=" + fnName + " caller=tx_signer, senderAddress=[verifier,verifier], feeRecipient=[approver1, approver2], approval_sig=[valid,valid], expiration=[valid,invalid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds1, approvalExpirationTimeSeconds2, approval1, approval2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, __assign({}, defaultOrder, { feeRecipientAddress: approvalSignerAddress2 })];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds1 = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approvalExpirationTimeSeconds2 = new utils_1.BigNumber(currentTimestamp).minus(src_1.constants.TIME_BUFFER);
                            approval1 = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds1);
                            approval2 = approvalFactory2.newSignedApproval(transaction, approvalExpirationTimeSeconds2);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds1, approvalExpirationTimeSeconds2], [approval1.signature, approval2.signature], { from: transactionSignerAddress }), types_1.RevertReason.ApprovalExpired);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds1, approvalExpirationTimeSeconds2], [approval1.signature, approval2.signature], { from: transactionSignerAddress }), types_1.RevertReason.ApprovalExpired);
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should revert: function=" + fnName + " caller=approver1, senderAddress=[verifier,verifier], feeRecipient=[approver1, approver2], approval_sig=[valid], expiration=[invalid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, __assign({}, defaultOrder, { feeRecipientAddress: approvalSignerAddress2 })];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).minus(src_1.constants.TIME_BUFFER);
                            approval2 = approvalFactory2.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval2.signature], { from: approvalSignerAddress1 }), types_1.RevertReason.ApprovalExpired);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval2.signature], { from: approvalSignerAddress1 }), types_1.RevertReason.ApprovalExpired);
                            return [2 /*return*/];
                    }
                });
            }); });
            it("Should revert: function=" + fnName + " caller=approver2, senderAddress=[verifier,verifier], feeRecipient=[approver1, approver1], approval_sig=[valid], expiration=[valid]", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            orders = [defaultOrder, defaultOrder];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = transactionFactory.newSignedTECTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 1:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval1 = approvalFactory1.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTransactionOrdersApproval.callAsync(transaction, orders, transaction.signature, [approvalExpirationTimeSeconds], [approval1.signature], { from: approvalSignerAddress2 }), types_1.RevertReason.InvalidSender);
                            contracts_test_utils_1.expectContractCallFailedAsync(mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval1.signature], { from: approvalSignerAddress2 }), types_1.RevertReason.InvalidSender);
                            return [2 /*return*/];
                    }
                });
            }); });
        };
        try {
            for (var _b = __values(__spread(src_1.constants.BATCH_FILL_FN_NAMES, src_1.constants.MARKET_FILL_FN_NAMES, [
                src_1.constants.MATCH_ORDERS,
            ])), _c = _b.next(); !_c.done; _c = _b.next()) {
                var fnName = _c.value;
                _loop_2(fnName);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
    });
    describe('cancels', function () {
        it('should allow the tx signer to call `cancelOrders` without approval', function () { return __awaiter(_this, void 0, void 0, function () {
            var orders, data, transaction;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        orders = [defaultOrder];
                        data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(src_1.constants.CANCEL_ORDERS, orders);
                        transaction = transactionFactory.newSignedTECTransaction(data);
                        return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [], [], {
                                from: transactionSignerAddress,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should allow the tx signer to call `batchCancelOrders` without approval', function () { return __awaiter(_this, void 0, void 0, function () {
            var orders, data, transaction;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        orders = [defaultOrder, defaultOrder];
                        data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(src_1.constants.BATCH_CANCEL_ORDERS, orders);
                        transaction = transactionFactory.newSignedTECTransaction(data);
                        return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [], [], {
                                from: transactionSignerAddress,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should allow the tx signer to call `cancelOrdersUpTo` without approval', function () { return __awaiter(_this, void 0, void 0, function () {
            var orders, data, transaction;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        orders = [];
                        data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(src_1.constants.CANCEL_ORDERS_UP_TO, orders);
                        transaction = transactionFactory.newSignedTECTransaction(data);
                        return [4 /*yield*/, mixins.assertValidTECApprovals.callAsync(transaction, transaction.signature, [], [], {
                                from: transactionSignerAddress,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
// tslint:disable:max-file-line-count
//# sourceMappingURL=mixins.js.map