"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var contracts_asset_proxy_1 = require("@0x/contracts-asset-proxy");
var contracts_exchange_1 = require("@0x/contracts-exchange");
var contracts_test_utils_1 = require("@0x/contracts-test-utils");
var dev_utils_1 = require("@0x/dev-utils");
var order_utils_1 = require("@0x/order-utils");
var types_1 = require("@0x/types");
var utils_1 = require("@0x/utils");
var chai = require("chai");
var src_1 = require("../src");
contracts_test_utils_1.chaiSetup.configure();
var expect = chai.expect;
var blockchainLifecycle = new dev_utils_1.BlockchainLifecycle(contracts_test_utils_1.web3Wrapper);
contracts_test_utils_1.web3Wrapper.abiDecoder.addABI(contracts_exchange_1.artifacts.Exchange.compilerOutput.abi);
// tslint:disable:no-unnecessary-type-assertion
describe('TEC tests', function () {
    var makerAddress;
    var owner;
    var takerAddress;
    var feeRecipientAddress;
    var erc20Proxy;
    var erc20TokenA;
    var erc20TokenB;
    var zrxToken;
    var tecContract;
    var exchange;
    var erc20Wrapper;
    var orderFactory;
    var takerTransactionFactory;
    var makerTransactionFactory;
    var approvalFactory;
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c, accounts, usedAddresses, numDummyErc20ToDeploy, _d, _e, _f, _g, defaultOrderParams, makerPrivateKey, takerPrivateKey, feeRecipientPrivateKey;
        return __generator(this, function (_h) {
            switch (_h.label) {
                case 0: return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.getAvailableAddressesAsync()];
                case 1:
                    accounts = _h.sent();
                    usedAddresses = (_a = accounts.slice(0, 4), _b = __read(_a, 4), owner = _b[0], makerAddress = _b[1], takerAddress = _b[2], feeRecipientAddress = _b[3], _a);
                    erc20Wrapper = new contracts_asset_proxy_1.ERC20Wrapper(contracts_test_utils_1.provider, usedAddresses, owner);
                    return [4 /*yield*/, erc20Wrapper.deployProxyAsync()];
                case 2:
                    erc20Proxy = _h.sent();
                    numDummyErc20ToDeploy = 3;
                    return [4 /*yield*/, erc20Wrapper.deployDummyTokensAsync(numDummyErc20ToDeploy, contracts_test_utils_1.constants.DUMMY_TOKEN_DECIMALS)];
                case 3:
                    _c = __read.apply(void 0, [_h.sent(), 3]), erc20TokenA = _c[0], erc20TokenB = _c[1], zrxToken = _c[2];
                    return [4 /*yield*/, erc20Wrapper.setBalancesAndAllowancesAsync()];
                case 4:
                    _h.sent();
                    return [4 /*yield*/, contracts_exchange_1.ExchangeContract.deployFrom0xArtifactAsync(contracts_exchange_1.artifacts.Exchange, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults, order_utils_1.assetDataUtils.encodeERC20AssetData(zrxToken.address))];
                case 5:
                    exchange = _h.sent();
                    _e = (_d = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, erc20Proxy.addAuthorizedAddress.sendTransactionAsync(exchange.address, { from: owner })];
                case 6: return [4 /*yield*/, _e.apply(_d, [_h.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 7:
                    _h.sent();
                    _g = (_f = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, exchange.registerAssetProxy.sendTransactionAsync(erc20Proxy.address, { from: owner })];
                case 8: return [4 /*yield*/, _g.apply(_f, [_h.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 9:
                    _h.sent();
                    return [4 /*yield*/, src_1.TECContract.deployFrom0xArtifactAsync(src_1.artifacts.TEC, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults, exchange.address)];
                case 10:
                    tecContract = _h.sent();
                    defaultOrderParams = __assign({}, contracts_test_utils_1.constants.STATIC_ORDER_PARAMS, { exchangeAddress: exchange.address, senderAddress: tecContract.address, makerAddress: makerAddress,
                        feeRecipientAddress: feeRecipientAddress, makerAssetData: order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address), takerAssetData: order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenB.address) });
                    makerPrivateKey = contracts_test_utils_1.constants.TESTRPC_PRIVATE_KEYS[accounts.indexOf(makerAddress)];
                    takerPrivateKey = contracts_test_utils_1.constants.TESTRPC_PRIVATE_KEYS[accounts.indexOf(takerAddress)];
                    feeRecipientPrivateKey = contracts_test_utils_1.constants.TESTRPC_PRIVATE_KEYS[accounts.indexOf(feeRecipientAddress)];
                    orderFactory = new contracts_test_utils_1.OrderFactory(makerPrivateKey, defaultOrderParams);
                    makerTransactionFactory = new contracts_test_utils_1.TransactionFactory(makerPrivateKey, exchange.address);
                    takerTransactionFactory = new contracts_test_utils_1.TransactionFactory(takerPrivateKey, exchange.address);
                    approvalFactory = new src_1.ApprovalFactory(feeRecipientPrivateKey, tecContract.address);
                    return [2 /*return*/];
            }
        });
    }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    describe('single order fills', function () {
        var e_1, _a;
        var _loop_1 = function (fnName) {
            it(fnName + " should fill the order with a signed approval", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval, transactionReceipt, _a, _b, fillLogs, fillLogArgs;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            orders = [_c.sent()];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 2:
                            currentTimestamp = _c.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: takerAddress })];
                        case 3: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 4:
                            transactionReceipt = _c.sent();
                            fillLogs = transactionReceipt.logs.filter(function (log) { return log.event === 'Fill'; });
                            expect(fillLogs.length).to.eq(1);
                            fillLogArgs = fillLogs[0].args;
                            expect(fillLogArgs.makerAddress).to.eq(makerAddress);
                            expect(fillLogArgs.takerAddress).to.eq(takerAddress);
                            expect(fillLogArgs.senderAddress).to.eq(tecContract.address);
                            expect(fillLogArgs.feeRecipientAddress).to.eq(feeRecipientAddress);
                            expect(fillLogArgs.makerAssetData).to.eq(orders[0].makerAssetData);
                            expect(fillLogArgs.takerAssetData).to.eq(orders[0].takerAssetData);
                            expect(fillLogArgs.makerAssetFilledAmount).to.bignumber.eq(orders[0].makerAssetAmount);
                            expect(fillLogArgs.takerAssetFilledAmount).to.bignumber.eq(orders[0].takerAssetAmount);
                            expect(fillLogArgs.makerFeePaid).to.bignumber.eq(orders[0].makerFee);
                            expect(fillLogArgs.takerFeePaid).to.bignumber.eq(orders[0].takerFee);
                            expect(fillLogArgs.orderHash).to.eq(order_utils_1.orderHashUtils.getOrderHashHex(orders[0]));
                            return [2 /*return*/];
                    }
                });
            }); });
            it(fnName + " should fill the order if called by approver", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, transactionReceipt, _a, _b, fillLogs, fillLogArgs;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            orders = [_c.sent()];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [], [], { from: feeRecipientAddress })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            transactionReceipt = _c.sent();
                            fillLogs = transactionReceipt.logs.filter(function (log) { return log.event === 'Fill'; });
                            expect(fillLogs.length).to.eq(1);
                            fillLogArgs = fillLogs[0].args;
                            expect(fillLogArgs.makerAddress).to.eq(makerAddress);
                            expect(fillLogArgs.takerAddress).to.eq(takerAddress);
                            expect(fillLogArgs.senderAddress).to.eq(tecContract.address);
                            expect(fillLogArgs.feeRecipientAddress).to.eq(feeRecipientAddress);
                            expect(fillLogArgs.makerAssetData).to.eq(orders[0].makerAssetData);
                            expect(fillLogArgs.takerAssetData).to.eq(orders[0].takerAssetData);
                            expect(fillLogArgs.makerAssetFilledAmount).to.bignumber.eq(orders[0].makerAssetAmount);
                            expect(fillLogArgs.takerAssetFilledAmount).to.bignumber.eq(orders[0].takerAssetAmount);
                            expect(fillLogArgs.makerFeePaid).to.bignumber.eq(orders[0].makerFee);
                            expect(fillLogArgs.takerFeePaid).to.bignumber.eq(orders[0].takerFee);
                            expect(fillLogArgs.orderHash).to.eq(order_utils_1.orderHashUtils.getOrderHashHex(orders[0]));
                            return [2 /*return*/];
                    }
                });
            }); });
            it(fnName + " should revert with no approval signature", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            orders = [_a.sent()];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [], [], {
                                    from: takerAddress,
                                    gas: contracts_test_utils_1.constants.MAX_EXECUTE_TRANSACTION_GAS,
                                }), types_1.RevertReason.InvalidApprovalSignature)];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it(fnName + " should revert with an invalid approval signature", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval, signature;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            orders = [_a.sent()];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 2:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            signature = approval.signature.slice(0, 4) + "FFFFFFFF" + approval.signature.slice(12);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [signature], { from: takerAddress }), types_1.RevertReason.InvalidApprovalSignature)];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it(fnName + " should revert with an expired approval", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            orders = [_a.sent()];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 2:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).minus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: takerAddress }), types_1.RevertReason.ApprovalExpired)];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it(fnName + " should revert if not called by tx signer or approver", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            orders = [_a.sent()];
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 2:
                            currentTimestamp = _a.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: owner }), types_1.RevertReason.InvalidSender)];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
        };
        try {
            for (var _b = __values(src_1.constants.SINGLE_FILL_FN_NAMES), _c = _b.next(); !_c.done; _c = _b.next()) {
                var fnName = _c.value;
                _loop_1(fnName);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
    describe('batch order fills', function () {
        var e_2, _a;
        var _loop_2 = function (fnName) {
            it(fnName + " should fill the orders with a signed approval", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, _a, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval, transactionReceipt, _b, _c, fillLogs;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            _a = [_d.sent()];
                            return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 2:
                            orders = _a.concat([_d.sent()]);
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 3:
                            currentTimestamp = _d.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            _c = (_b = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: takerAddress, gas: contracts_test_utils_1.constants.MAX_EXECUTE_TRANSACTION_GAS })];
                        case 4: return [4 /*yield*/, _c.apply(_b, [_d.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 5:
                            transactionReceipt = _d.sent();
                            fillLogs = transactionReceipt.logs.filter(function (log) { return log.event === 'Fill'; });
                            expect(fillLogs.length).to.eq(orders.length);
                            orders.forEach(function (order, index) {
                                var fillLogArgs = fillLogs[index].args;
                                expect(fillLogArgs.makerAddress).to.eq(makerAddress);
                                expect(fillLogArgs.takerAddress).to.eq(takerAddress);
                                expect(fillLogArgs.senderAddress).to.eq(tecContract.address);
                                expect(fillLogArgs.feeRecipientAddress).to.eq(feeRecipientAddress);
                                expect(fillLogArgs.makerAssetData).to.eq(order.makerAssetData);
                                expect(fillLogArgs.takerAssetData).to.eq(order.takerAssetData);
                                expect(fillLogArgs.makerAssetFilledAmount).to.bignumber.eq(order.makerAssetAmount);
                                expect(fillLogArgs.takerAssetFilledAmount).to.bignumber.eq(order.takerAssetAmount);
                                expect(fillLogArgs.makerFeePaid).to.bignumber.eq(order.makerFee);
                                expect(fillLogArgs.takerFeePaid).to.bignumber.eq(order.takerFee);
                                expect(fillLogArgs.orderHash).to.eq(order_utils_1.orderHashUtils.getOrderHashHex(order));
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it(fnName + " should fill the orders if called by approver", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, _a, data, transaction, transactionReceipt, _b, _c, fillLogs;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            _a = [_d.sent()];
                            return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 2:
                            orders = _a.concat([_d.sent()]);
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            _c = (_b = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [], [], { from: feeRecipientAddress, gas: contracts_test_utils_1.constants.MAX_EXECUTE_TRANSACTION_GAS })];
                        case 3: return [4 /*yield*/, _c.apply(_b, [_d.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 4:
                            transactionReceipt = _d.sent();
                            fillLogs = transactionReceipt.logs.filter(function (log) { return log.event === 'Fill'; });
                            expect(fillLogs.length).to.eq(orders.length);
                            orders.forEach(function (order, index) {
                                var fillLogArgs = fillLogs[index].args;
                                expect(fillLogArgs.makerAddress).to.eq(makerAddress);
                                expect(fillLogArgs.takerAddress).to.eq(takerAddress);
                                expect(fillLogArgs.senderAddress).to.eq(tecContract.address);
                                expect(fillLogArgs.feeRecipientAddress).to.eq(feeRecipientAddress);
                                expect(fillLogArgs.makerAssetData).to.eq(order.makerAssetData);
                                expect(fillLogArgs.takerAssetData).to.eq(order.takerAssetData);
                                expect(fillLogArgs.makerAssetFilledAmount).to.bignumber.eq(order.makerAssetAmount);
                                expect(fillLogArgs.takerAssetFilledAmount).to.bignumber.eq(order.takerAssetAmount);
                                expect(fillLogArgs.makerFeePaid).to.bignumber.eq(order.makerFee);
                                expect(fillLogArgs.takerFeePaid).to.bignumber.eq(order.takerFee);
                                expect(fillLogArgs.orderHash).to.eq(order_utils_1.orderHashUtils.getOrderHashHex(order));
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it(fnName + " should revert with an invalid approval signature", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, _a, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval, signature;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            _a = [_b.sent()];
                            return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 2:
                            orders = _a.concat([_b.sent()]);
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 3:
                            currentTimestamp = _b.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            signature = approval.signature.slice(0, 4) + "FFFFFFFF" + approval.signature.slice(12);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [signature], { from: takerAddress }), types_1.RevertReason.InvalidApprovalSignature)];
                        case 4:
                            _b.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it(fnName + " should revert with an expired approval", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, _a, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            _a = [_b.sent()];
                            return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 2:
                            orders = _a.concat([_b.sent()]);
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 3:
                            currentTimestamp = _b.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).minus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: takerAddress }), types_1.RevertReason.ApprovalExpired)];
                        case 4:
                            _b.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it(fnName + " should revert if not called by tx signer or approver", function () { return __awaiter(_this, void 0, void 0, function () {
                var orders, _a, data, transaction, currentTimestamp, approvalExpirationTimeSeconds, approval;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 1:
                            _a = [_b.sent()];
                            return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                        case 2:
                            orders = _a.concat([_b.sent()]);
                            data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(fnName, orders);
                            transaction = takerTransactionFactory.newSignedTransaction(data);
                            return [4 /*yield*/, contracts_test_utils_1.getLatestBlockTimestampAsync()];
                        case 3:
                            currentTimestamp = _b.sent();
                            approvalExpirationTimeSeconds = new utils_1.BigNumber(currentTimestamp).plus(src_1.constants.TIME_BUFFER);
                            approval = approvalFactory.newSignedApproval(transaction, approvalExpirationTimeSeconds);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [approvalExpirationTimeSeconds], [approval.signature], { from: owner }), types_1.RevertReason.InvalidSender)];
                        case 4:
                            _b.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
        };
        try {
            for (var _b = __values(__spread(src_1.constants.MARKET_FILL_FN_NAMES, src_1.constants.BATCH_FILL_FN_NAMES)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var fnName = _c.value;
                _loop_2(fnName);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
    });
    describe('cancels', function () {
        it('cancelOrder call should be successful without an approval', function () { return __awaiter(_this, void 0, void 0, function () {
            var orders, data, transaction, transactionReceipt, _a, _b, cancelLogs, cancelLogArgs;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                    case 1:
                        orders = [_c.sent()];
                        data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(src_1.constants.CANCEL_ORDERS, orders);
                        transaction = makerTransactionFactory.newSignedTransaction(data);
                        _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                        return [4 /*yield*/, tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [], [], {
                                from: makerAddress,
                            })];
                    case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent()])];
                    case 3:
                        transactionReceipt = _c.sent();
                        cancelLogs = transactionReceipt.logs.filter(function (log) { return log.event === 'Cancel'; });
                        expect(cancelLogs.length).to.eq(1);
                        cancelLogArgs = cancelLogs[0].args;
                        expect(cancelLogArgs.makerAddress).to.eq(makerAddress);
                        expect(cancelLogArgs.senderAddress).to.eq(tecContract.address);
                        expect(cancelLogArgs.feeRecipientAddress).to.eq(feeRecipientAddress);
                        expect(cancelLogArgs.makerAssetData).to.eq(orders[0].makerAssetData);
                        expect(cancelLogArgs.takerAssetData).to.eq(orders[0].takerAssetData);
                        expect(cancelLogArgs.orderHash).to.eq(order_utils_1.orderHashUtils.getOrderHashHex(orders[0]));
                        return [2 /*return*/];
                }
            });
        }); });
        it('batchCancelOrders call should be successful without an approval', function () { return __awaiter(_this, void 0, void 0, function () {
            var orders, _a, data, transaction, transactionReceipt, _b, _c, cancelLogs;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                    case 1:
                        _a = [_d.sent()];
                        return [4 /*yield*/, orderFactory.newSignedOrderAsync()];
                    case 2:
                        orders = _a.concat([_d.sent()]);
                        data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(src_1.constants.BATCH_CANCEL_ORDERS, orders);
                        transaction = makerTransactionFactory.newSignedTransaction(data);
                        _c = (_b = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                        return [4 /*yield*/, tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [], [], {
                                from: makerAddress,
                            })];
                    case 3: return [4 /*yield*/, _c.apply(_b, [_d.sent()])];
                    case 4:
                        transactionReceipt = _d.sent();
                        cancelLogs = transactionReceipt.logs.filter(function (log) { return log.event === 'Cancel'; });
                        expect(cancelLogs.length).to.eq(orders.length);
                        orders.forEach(function (order, index) {
                            var cancelLogArgs = cancelLogs[index].args;
                            expect(cancelLogArgs.makerAddress).to.eq(makerAddress);
                            expect(cancelLogArgs.senderAddress).to.eq(tecContract.address);
                            expect(cancelLogArgs.feeRecipientAddress).to.eq(feeRecipientAddress);
                            expect(cancelLogArgs.makerAssetData).to.eq(order.makerAssetData);
                            expect(cancelLogArgs.takerAssetData).to.eq(order.takerAssetData);
                            expect(cancelLogArgs.orderHash).to.eq(order_utils_1.orderHashUtils.getOrderHashHex(order));
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('cancelOrdersUpTo call should be successful without an approval', function () { return __awaiter(_this, void 0, void 0, function () {
            var orders, data, transaction, transactionReceipt, _a, _b, cancelLogs, cancelLogArgs;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        orders = [];
                        data = src_1.exchangeDataEncoder.encodeOrdersToExchangeData(src_1.constants.CANCEL_ORDERS_UP_TO, orders);
                        transaction = makerTransactionFactory.newSignedTransaction(data);
                        _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                        return [4 /*yield*/, tecContract.executeTransaction.sendTransactionAsync(transaction, transaction.signature, [], [], {
                                from: makerAddress,
                            })];
                    case 1: return [4 /*yield*/, _b.apply(_a, [_c.sent()])];
                    case 2:
                        transactionReceipt = _c.sent();
                        cancelLogs = transactionReceipt.logs.filter(function (log) { return log.event === 'CancelUpTo'; });
                        expect(cancelLogs.length).to.eq(1);
                        cancelLogArgs = cancelLogs[0].args;
                        expect(cancelLogArgs.makerAddress).to.eq(makerAddress);
                        expect(cancelLogArgs.senderAddress).to.eq(tecContract.address);
                        expect(cancelLogArgs.orderEpoch).to.bignumber.eq(new utils_1.BigNumber(1));
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=tec.js.map