"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var ethUtil = require("ethereumjs-util");
var index_1 = require("./index");
var ApprovalFactory = /** @class */ (function () {
    function ApprovalFactory(privateKey, verifyingContractAddress) {
        this._privateKey = privateKey;
        this._verifyingContractAddress = verifyingContractAddress;
    }
    ApprovalFactory.prototype.newSignedApproval = function (transaction, approvalExpirationTimeSeconds, signatureType) {
        if (signatureType === void 0) { signatureType = index_1.TECSignatureType.EthSign; }
        var tecTransaction = __assign({}, transaction, { verifyingContractAddress: this._verifyingContractAddress });
        var approvalHashBuff = index_1.hashUtils.getApprovalHashBuffer(tecTransaction, approvalExpirationTimeSeconds);
        var signatureBuff = index_1.signingUtils.signMessage(approvalHashBuff, this._privateKey, signatureType);
        var signedApproval = {
            transaction: tecTransaction,
            approvalExpirationTimeSeconds: approvalExpirationTimeSeconds,
            signature: ethUtil.addHexPrefix(signatureBuff.toString('hex')),
        };
        return signedApproval;
    };
    return ApprovalFactory;
}());
exports.ApprovalFactory = ApprovalFactory;
//# sourceMappingURL=approval_factory.js.map