"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var order_utils_1 = require("@0x/order-utils");
var ethUtil = require("ethereumjs-util");
var index_1 = require("./index");
var TECTransactionFactory = /** @class */ (function () {
    function TECTransactionFactory(privateKey, verifyingContractAddress) {
        this._privateKey = privateKey;
        this._verifyingContractAddress = verifyingContractAddress;
        this._signerBuff = ethUtil.privateToAddress(this._privateKey);
    }
    TECTransactionFactory.prototype.newSignedTECTransaction = function (data, signatureType) {
        if (signatureType === void 0) { signatureType = index_1.TECSignatureType.EthSign; }
        var transaction = {
            verifyingContractAddress: this._verifyingContractAddress,
            signerAddress: ethUtil.addHexPrefix(this._signerBuff.toString('hex')),
            salt: order_utils_1.generatePseudoRandomSalt(),
            data: data,
        };
        var transactionHashBuff = index_1.hashUtils.getTransactionHashBuffer(transaction);
        var signatureBuff = index_1.signingUtils.signMessage(transactionHashBuff, this._privateKey, signatureType);
        var signedTransaction = __assign({}, transaction, { signature: ethUtil.addHexPrefix(signatureBuff.toString('hex')) });
        return signedTransaction;
    };
    return TECTransactionFactory;
}());
exports.TECTransactionFactory = TECTransactionFactory;
//# sourceMappingURL=tec_transaction_factory.js.map